// tNXDateiSŁF\[Xj

#include <ctime>
#include <sstream>
#include <iostream>
#include "Date.h"

using namespace std;

// N̊e̓
int Date::dmax[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

//--- yNm̓߂ ---//
int Date::days_of_month(int y, int m)
{
	return dmax[m - 1] + (is_leap(y) && m == 2);
}

//--- DatẽftHgRXgN^i̓tɐݒj---//
Date::Date()
{
	time_t current = time(NULL);				// ݂̗擾
	struct tm* local = localtime(&current);		// vfʂ̎ɕϊ

	y = local->tm_year + 1900;		// NFtm_year͐N-1900
	m = local->tm_mon + 1;			// Ftm_mon0`11
	d = local->tm_mday;
}

//--- DatẽRXgN^iw肳ꂽNɐݒj---//
Date::Date(int yy, int mm, int dd)
{
	y = yy;
	m = mm;
	d = dd;
}

//--- Ňoߓԋp ---//
int Date::day_of_year() const
{
	int days = d;	// Ňoߓ

	for (int i = 1; i < m; i++)			// 1`(m-1)̓
		days += days_of_month(y, i);
	return days;
}

//--- O̓tԋp ---//
Date Date::preceding_day() const
{
	Date temp = *this;		// ̓t

	if (temp.d > 1)
		temp.d--;
	else {
		if (--temp.m < 1) {
			temp.y--;
			temp.m = 12;
		}
		temp.d = days_of_month(temp.y, temp.m);
	}
	return temp;
}

//--- ̓tԋp ---//
Date Date::following_day() const
{
	Date temp = *this;		// ̓t

	if (temp.d < days_of_month(temp.y, temp.m))
		temp.d++;
	else {
		if (++temp.m > 12) {
			temp.y++;
			temp.m = 1;
		}
		temp.d = 1;
	}
	return temp;
}

//--- \ԋp ---//
string Date::to_string() const
{
	ostringstream s;
	s << y << "N" << m << "" << d << "";
	return s.str();
}

//--- jԋpij`yj0`6ɑΉj---//
int Date::day_of_week() const
{
	int yy = y;
	int mm = m;
	if (mm == 1 || mm == 2) {
		yy--;
		mm += 12;
	}
	return (yy + yy / 4 - yy / 100 + yy / 400 + (13 * mm + 8) / 5 + d) % 7;
}

//--- o̓Xg[sx} ---//
ostream& operator<<(ostream& s, const Date& x)
{
	return s << x.to_string();
}

//--- ̓Xg[st𒊏oxɊi[ ---//
istream& operator>>(istream& s, Date& x)
{
	int yy, mm, dd;
	char ch;

	s >> yy >> ch >> mm >> ch >> dd;
	x = Date(yy, mm, dd);
	return s;
}
