// tNXDateiTŁF\[Xj

#include <ctime>
#include <sstream>
#include <iostream>
#include "Date.h"

using namespace std;

// N̊e̓
int Date::dmax[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

//--- yNm̓߂ ---//
int Date::days_of_month(int y, int m)
{
	return dmax[m - 1] + (m == 2 && leap_year(y));
}

//--- yearN̓iNc365^[Nc366j---//
int Date::days_of_year(int year)
{
	return 365 + leap_year(year);
}

//--- ꂽmi1`12͈̔͊O̒l𒲐j---//
int Date::adjusted_month(int m)
{
	return m < 1 ? 1 : m > 12 ? 12 : m;
}

//--- ꂽyNmdi1`28/29/30/31͈̔͊O̒l𒲐j---//
int Date::adjusted_day(int y, int m, int d)
{
	if (d < 1)
		return 1;

	int max_day = days_of_month(y, m);		// yNm̓

	return d > max_day ? max_day : d;
}

//--- ftHgRXgN^i̓tɐݒj---//
Date::Date()
{
	time_t current = time(NULL);				// ݂̗擾
	struct tm* local = localtime(&current);		// vfʂ̎ɕϊ

	y = local->tm_year + 1900;		// NFtm_year͐N-1900
	m = local->tm_mon + 1;			// Ftm_mon0`11
	d = local->tm_mday;				// 
}

//--- RXgN^iw肳ꂽNɐݒj---//
Date::Date(int yy, int mm, int dd)
{
	set(yy, mm, dd);				// tyyNmmddɐݒ
}

//--- Nyyɐݒ ---//
void Date::set_year(int yy)
{
	y = yy;							// N
	d = adjusted_day(y, m, d);		// isȒl𒲐j
}

//--- mmɐݒ ---//
void Date::set_month(int mm)
{
	m = adjusted_month(mm);			// isȒl𒲐j
	d = adjusted_day(y, m, d);		// isȒl𒲐j
}

//--- ddɐݒ ---//
void Date::set_day(int dd)
{
	d = adjusted_day(y, m, dd);		// isȒl𒲐j
}

//--- tyyNmmddɐݒ ---//
void Date::set(int yy, int mm, int dd)
{
	y = yy;							// N
	m = adjusted_month(mm);			// isȒl𒲐j
	d = adjusted_day(y, m, dd);		// isȒl𒲐j
}

//--- O̓tԋp ---//
Date Date::preceding_day() const
{
	Date temp(*this);				// *this̃Rs[쐬
	return --temp;					// Rs[̑O߂ĕԋp
}

//--- ̓tԋp ---//
Date Date::following_day() const
{
	Date temp(*this);				// *this̃Rs[쐬
	return ++temp;					// Rs[̗߂ĕԋp
}

//--- Ňoߓԋp ---//
int Date::day_of_year() const
{
	int days = d;	// Ňoߓ

	for (int i = 1; i < m; i++)			// 1`(m-1)̓
		days += days_of_month(y, i);
	return days;
}

//--- jԋpij`yj0`6ɑΉj---//
int Date::day_of_week() const
{
	int yy = y;
	int mm = m;
	if (mm == 1 || mm == 2) {
		yy--;
		mm += 12;
	}
	return (yy + yy / 4 - yy / 100 + yy / 400 + (13 * mm + 8) / 5 + d) % 7;
}

//--- \ԋp ---//
string Date::to_string() const
{
	ostringstream s;
	s << y << "N" << m << "" << d << "";
	return s.str();
}

//--- Pi߂iOuF++(*this)j---//
Date& Date::operator++()
{
	if (d < days_of_month(y, m))	// Oł
		d++;						// @@CNg邾
	else {							// ɌJオ
		if (++m > 12) {				// @@12𒴂̂ł
			y++;					// @@@@@Ńc
			m = 1;					// @@@@@PɌJオ
		}
		d = 1;						// @@̌̂PƂȂ
	}
	return *this;
}

//--- Pi߂iuF(*this)++j---//
Date Date::operator++(int)
{
	Date temp(*this);				// CNgO̒lRs[
	++(*this);						// OuZq++ɂăCNg
	return temp;					// Rs[ԋp
}

//--- P߂iOuF--(*this)j---//
Date& Date::operator--()
{
	if (d > 1)						// n߂łȂ
		d--;						// @@fNg邾
	else {							// OɌJ艺
		if (--m <= 1) {				// @@P𒴂̂ł
			y--;					// @@@@@OŃc
			m = 12;					// @@@@@12ɌJ艺
		}
		d = days_of_month(y, m);	// @@ǑƂȂ
	}
	return *this;
}

//--- P߂iuF(*this)--j---//
Date Date::operator--(int)
{
	Date temp(*this);				// fNgO̒lRs[
	--(*this);						// OuZq--ɂăfNg
	return temp;					// Rs[ԋp
}

//--- tni߂iF*this += nj---//
Date& Date::operator+=(int n)
{
	if (n < 0)							// nł
		return *this -= -n;			// Zq-=ɏς˂

	d += n;							// n

	while (d > days_of_month(y, m)) {	// ̓Ɏ܂悤ɔN𒲐
		d -= days_of_month(y, m);
		if (++m > 12) {
			y++;
			m = 1;
		}
	}
	return *this;
}

//--- tn߂iF*this -= intj---//
Date& Date::operator-=(int n)
{
	if (n < 0)							// nł
		return *this += -n;			// Zq+=ɏς˂

	d -= n;							// n

	while (d < 1) {						// ɂȂ悤ɔN𒲐
		if (--m < 1) {
			y--;
			m = 12;
		}
		d += days_of_month(y, m);
	}
	return *this;
}

//--- n߂iZF*this + nj---//
Date Date::operator+(int n) const
{
	Date temp(*this);
	return temp += n;						// Zq+=𗘗p
}

//--- dayn߂iZFn + dayj---//
Date operator+(int n, const Date& day)
{
	return day + n;						// Date + int̉Zq+ɏς˂
}

//--- datenO߂iZF*this - nj---//
Date Date::operator-(int n) const
{
	Date temp(*this);
	return temp -= n;						// Zq-=𗘗p
}

//--- t̍߂iZF*this - dayj---//
long Date::operator-(const Date& day) const
{
	long count;
	long count1 = this->day_of_year();	// *this̔Noߓ
	long count2 = day.day_of_year();	// day  ̔Noߓ

	if (y == day.y)										// *thisday͓N
		count = count1 - count2;
	else if (y > day.y) {								// *thiŝقVN
		count = days_of_year(day.y) - count2 + count1;
		for (int yy = day.y + 1; yy < y; yy++)
			count += days_of_year(yy);
	} else {											// *thiŝقÂN
		count = -(days_of_year(y) - count1 + count2);
		for (int yy = y + 1; yy < day.y; yy++)
			count -= days_of_year(yy);
	}

	return count;
}

//--- dayƓtHiF*this == dayj---//
bool Date::operator==(const Date& day) const
{
	return y == day.y && m == day.m && d == day.d;
}

//--- dayƈႤtHiF*this != dayj---//
bool Date::operator!=(const Date& day) const
{
	return !(*this == day);						// Zq==𗘗p
}

//--- day̐VtHi֌WF*this > dayj---//
bool Date::operator>(const Date& day) const
{
	if (y > day.y) return true;		// NقȂiVj
	if (y < day.y) return false;	//     V@@iÂj

	if (m > day.m) return true;		// N | قȂiVj
	if (m < day.m) return false;	//     V@@@@@@@@@iÂj

	return d > day.d;				//     V     | irj
}

//--- dayȍ~̓tHi֌WF*this >= dayj---//
bool Date::operator>=(const Date& day) const
{
	return !(*this < day);						// Zq<𗘗p
}

//--- dayǑÂtHi֌WF*this < dayj---//
bool Date::operator<(const Date& day) const
{
	if (y < day.y) return true;		// NقȂiÂj
	if (y > day.y) return false;	//     V    iVj

	if (m < day.m) return true;		// N | قȂiÂj
	if (m > day.m) return false;	//     V@@@@@@@@@iVj

	return d < day.d;				//     V     | irj
}

//--- dayȑO̓tHi֌WF*this <= dayj---//
bool Date::operator<=(const Date& day) const
{
	return !(*this > day);						// Zq>𗘗p
}

//--- o̓Xg[sɓtx} ---//
ostream& operator<<(ostream& s, const Date& x)
{
	return s << x.to_string();
}

//--- ̓Xg[st𒊏oxɊi[ ---//
istream& operator>>(istream& s, Date& x)
{
	int yy, mm, dd;
	char ch;

	s >> yy >> ch >> mm >> ch >> dd;
	x = Date(yy, mm, dd);
	return s;
}