// tNXDateiTŁFwb_j

#ifndef ___Class_Date
#define ___Class_Date

#include <string>
#include <iostream>

//===== tNX =====//
class Date {
	int y;	// N
	int m;	// 
	int d;	// 

	static int dmax[];
	static int days_of_year(int y);				// yN̓
	static int days_of_month(int y, int m);		// yNm̓

	// ꂽi1`12͈̔͊O̕sȒl𒲐j
	static int adjusted_month(int m);

	// ꂽyNmdi1`28/29/30/31͈̔͊O̕sȒl𒲐j
	static int adjusted_day(int y, int m, int d);

public:
	Date();										// ftHgRXgN^
	Date(int yy, int mm = 1, int dd = 1);		// RXgN^

	//--- yearN͉[NH ---//
	static bool leap_year(int year) {
		return year % 4 == 0 && year % 100 != 0 || year % 400 == 0;
	}

	int year()  const { return y; }			// Nԋp
	int month() const { return m; }			// ԋp
	int day()   const { return d; }			// ԋp

	void set_year( int yy);					// Nyyɐݒ
	void set_month(int mm);					// mmɐݒ
	void set_day(  int dd);					// ddɐݒ

	void set(int yy, int mm, int dd);		// tyyNmmddɐݒ

	bool leap_year() const { return leap_year(y); }		// [NH

	Date preceding_day() const;				// O̓tԋp
	Date following_day() const;				// ̓tԋp

	int day_of_year() const;				// Ňoߓԋp

	int day_of_week() const;				// jԋp

	std::string to_string() const;			// \ԋp

	Date& operator++();							// Pi߂iOuj
	Date  operator++(int);						// Pi߂iuj

	Date& operator--();							// P߂@iOuj
	Date  operator--(int);						// P߂@iuj

	Date& operator+=(int n);					// ni߂iDate += intj
	Date& operator-=(int n);					// n߂@iDate -= intj

	Date operator+(int n) const;					 // n߂iDate + intj
	friend Date operator+(int n, const Date& date);  // n߂iint + Datej

	Date operator-(int n) const;				// nO߂@iDate - intj

	long operator-(const Date& day) const;		// t̍߂iDate - Datej

	bool operator==(const Date& day) const;		// dayƓH
	bool operator!=(const Date& day) const;		// dayƈႤH

	bool operator> (const Date& day) const;		// dayォH
	bool operator>=(const Date& day) const;		// dayȍ~H
	bool operator< (const Date& day) const;		// dayOH
	bool operator<=(const Date& day) const;		// dayȑOH
};

std::ostream& operator<<(std::ostream& s, const Date& x);	// }q
std::istream& operator>>(std::istream& s,       Date& x);	// oq

#endif
